﻿Imports System.Runtime.InteropServices
Imports MaxIm

<ComClass(PlugIn.ClassId, PlugIn.InterfaceId, PlugIn.EventsId)>
Public Class PlugIn

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "2B8174E0-2CDF-4AB7-A1FB-9D3C0B05A7DF"
    Public Const InterfaceId As String = "D35119B2-3AD6-478E-A243-9E5B9E5F6CA9"
    Public Const EventsId As String = "D6B1EF1D-34B6-41F4-9B79-C01931A7A26A"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub DoModal(ByVal Doc As MaxIm.Document)



        Dim W As Short
        W = Doc.XSize
        Dim H As Short
        H = Doc.YSize


        Dim isColor As Boolean
        isColor = Doc.Color


        If (isColor) Then
            Dim Image(,,) As Single
            Image = Doc.ImageArray
            For I = 0 To W - 1
                For J = 0 To H - 1
                    Image(0, I, J) = Image(0, I, J) + 50
                    Image(1, I, J) = Image(1, I, J) + 150
                    Image(2, I, J) = Image(2, I, J) + 200
                Next
            Next
            Doc.ImageArray = Image
        Else
            Dim Image(,) As Single
            Image = Doc.ImageArray
            For I = 0 To W - 1
                For J = 0 To H - 1
                    Image(I, J) = Image(I, J) + 100
                Next
            Next
            Doc.ImageArray = Image
        End If

        Doc.Modified = True

    End Sub

    Public ReadOnly Property Name() As String
        Get
            Return "MaxIm DL Sample VB.Net Plugin - AddConstant"
        End Get
    End Property

End Class




