﻿Imports System.Runtime.InteropServices
Imports MaxIm

<ComClass(PlugIn.ClassId, PlugIn.InterfaceId, PlugIn.EventsId)>
Public Class PlugIn

#Region "COM GUIDs"
    ' These  GUIDs provide the COM identity for this class 
    ' and its COM interfaces. If you change them, existing 
    ' clients will no longer be able to access the class.
    Public Const ClassId As String = "51374460-AD84-4404-B1CA-E8DC689B65DC"
    Public Const InterfaceId As String = "04A809D1-6740-44C4-A645-7F08E98DD762"
    Public Const EventsId As String = "B3DD5EF8-EE13-41B2-B05B-41D7B3A202D8"
#End Region

    ' A creatable COM class must have a Public Sub New() 
    ' with no parameters, otherwise, the class will not be 
    ' registered in the COM registry and cannot be created 
    ' via CreateObject.
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub DoModal(ByVal Doc As MaxIm.Document)

        Dim myApp As New MaxIm.Application

        MsgBox("MaxIm/DL Version : " + myApp.Version.ToString())


        Marshal.ReleaseComObject(myApp)
    End Sub

    Public ReadOnly Property Name() As String
        Get
            Return "MaxIm DL Sample VB.Net Plugin - Version"
        End Get
    End Property

End Class



